<?php
namespace Teknisa\DF\Modules\Relatorios\Factories;

use Doctrine\ORM\EntityManager;

class Dfe22000DetalhamentoNotasFiscaisManifestadaFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function findNrNSU($NRORG,$NRINSJURIEST,$DTINSNRNSU,$IDAMBIENTENFE) {
        
        $sql = "SELECT DISTINCT
                    ( NSU.NRACESSONFE ),
                    NVL(RESLOC.RES_LOC, 'Não') AS RES_LOC,
                    NVL(DOCLOC.DOC_LOC, 'Não') AS DOC_LOC,
                    NVL(CANC.CANC, 'Não') AS CANC,
                    NSU.CNPJEMIT,
                    NSU.UFEMIT,
                    NSU.DTEMIS,
                    NSU.NRSER,
                    NSU.NRNUMNOTA,
                    NSU.FORMEMIT,
                    NSU.DTINC,
                    NSU.NRINSJURIEST,
                    NSU.IDAMBIENTENFE,
                    NSU.IDNRNSUFALTANTE,
                    EST.SGESTADO
                FROM
                    ESTADO EST,
                    (
                        SELECT
                            N.NRACESSONFE,
                            SUBSTR(N.NRACESSONFE, 7, 14) AS CNPJEMIT,
                            SUBSTR(N.NRACESSONFE, 1, 2) AS UFEMIT,
                            TO_CHAR(DTINSNRNSU, 'MM/YYYY') AS DTEMIS,
                            SUBSTR(N.NRACESSONFE, 23, 3) AS NRSER,
                            SUBSTR(N.NRACESSONFE, 26, 9) AS NRNUMNOTA,
                            SUBSTR(N.NRACESSONFE, 35, 1) AS FORMEMIT,
                            ( N.DTINSNRNSU ) AS DTINC,
                            N.NRINSJURIEST,
                            N.IDAMBIENTENFE,
                            DECODE(N.IDNRNSUFALTANTE, 'S', 'Sim', 'Não') as IDNRNSUFALTANTE
                        FROM
                            NSUNFE N
                        WHERE
                            NRACESSONFE IS NOT NULL
                            AND NRORG = :NRORG
                            AND NRINSJURIEST = :NRINSJURIEST
                            AND TO_CHAR(DTINSNRNSU, 'MM/YYYY') = :DTINSNRNSU
                            AND IDAMBIENTENFE = :IDAMBIENTENFE
                    ) NSU,
                    (
                        SELECT
                            NRACESSONFE,
                            SUBSTR(NRACESSONFE, 7, 14) AS CNPJEMIT,
                            SUBSTR(NRACESSONFE, 1, 2) AS UFEMIT,
                            TO_CHAR(DTINSNRNSU, 'MM/YYYY') AS DTEMIS,
                            SUBSTR(NRACESSONFE, 23, 3) AS NRSER,
                            SUBSTR(NRACESSONFE, 26, 9) AS NRNUMNOTA,
                            SUBSTR(NRACESSONFE, 35, 1) AS FORMEMIT,
                            ( DTINSNRNSU ) AS DTINC,
                            DECODE(CDSTATUS, 100, 'Sim', 'Não') AS DOC_LOC,
                            '' AS RES_LOC,
                            '' AS CANC,
                            NRINSJURIEST,
                            IDAMBIENTENFE
                        FROM
                            NSUNFE
                        WHERE
                            NRACESSONFE IS NOT NULL
                            AND NRORG = :NRORG
                            AND NRINSJURIEST = :NRINSJURIEST
                            AND TO_CHAR(DTINSNRNSU, 'MM/YYYY') = :DTINSNRNSU
                            AND IDAMBIENTENFE = :IDAMBIENTENFE           
                            AND CDSTATUS = '100'
                    ) DOCLOC,
                    (
                        SELECT
                            NRACESSONFE,
                            SUBSTR(NRACESSONFE, 7, 14) AS CNPJEMIT,
                            SUBSTR(NRACESSONFE, 1, 2) AS UFEMIT,
                            TO_CHAR(DTINSNRNSU, 'MM/YYYY') AS DTEMIS,
                            SUBSTR(NRACESSONFE, 23, 3) AS NRSER,
                            SUBSTR(NRACESSONFE, 26, 9) AS NRNUMNOTA,
                            SUBSTR(NRACESSONFE, 35, 1) AS FORMEMIT,
                            ( DTINSNRNSU ) AS DTINC,
                            '' AS DOC_LOC,
                            DECODE(CDSTATUS, 138, 'Sim', 'Não') AS RES_LOC,
                            '' AS CANC,
                            NRINSJURIEST,
                            IDAMBIENTENFE
                        FROM
                            NSUNFE
                        WHERE
                            NRACESSONFE IS NOT NULL
                            AND NRORG = :NRORG
                            AND NRINSJURIEST = :NRINSJURIEST
                            AND TO_CHAR(DTINSNRNSU, 'MM/YYYY') = :DTINSNRNSU
                            AND IDAMBIENTENFE = :IDAMBIENTENFE            
                            AND CDSTATUS = '138'
                    ) RESLOC,
                    (
                        SELECT
                            NRACESSONFE,
                            SUBSTR(NRACESSONFE, 7, 14) AS CNPJEMIT,
                            SUBSTR(NRACESSONFE, 1, 2) AS UFEMIT,
                            TO_CHAR(DTINSNRNSU, 'MM/YYYY') AS DTEMIS,
                            SUBSTR(NRACESSONFE, 23, 3) AS NRSER,
                            SUBSTR(NRACESSONFE, 26, 9) AS NRNUMNOTA,
                            SUBSTR(NRACESSONFE, 35, 1) AS FORMEMIT,
                            ( DTINSNRNSU ) AS DTINC,
                            '' AS DOC_LOC,
                            '' AS RES_LOC,
                            'Sim' AS CANC,
                            NRINSJURIEST,
                            IDAMBIENTENFE
                        FROM
                            NSUNFE
                        WHERE
                            NRACESSONFE IS NOT NULL
                            AND NRORG = :NRORG
                            AND NRINSJURIEST = :NRINSJURIEST
                            AND TO_CHAR(DTINSNRNSU, 'MM/YYYY') = :DTINSNRNSU
                            AND IDAMBIENTENFE = :IDAMBIENTENFE            
                            AND CDSERVICO = '110111'
                    ) CANC
                WHERE
                    NSU.NRACESSONFE = RESLOC.NRACESSONFE (+)
                    AND NSU.NRACESSONFE = DOCLOC.NRACESSONFE (+)
                    AND NSU.NRACESSONFE = CANC.NRACESSONFE (+)
                    AND EST.CDESTADOIBGE = SUBSTR(NSU.NRACESSONFE, 1, 2) ";

                     
        $params = array(
            "nrorg"         => $NRORG,
            "nrinsjuriest"  => $NRINSJURIEST,
            "dtinsnrnsu"    => $DTINSNRNSU,
            "idambientenfe" => $IDAMBIENTENFE
        );

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $dataSet = $std->fetchAll();
    }
    
    
    public function findHistNSU($NRACESSONFE) {
        
        $sql = " SELECT DECODE(IDNRNSUFALTANTE, 'S', 'Sim', 'Não') as IDNRNSUFALTANTE, CDOPERINCLUSAO, CDOPERULTATU, CDSERVICO, CDSTATUS, DSMOTIVO, DSSERVICO, DTINCLUSAO, DTINSNRNSU, DTRECBTO, DTULTATU, DTUPDNRNSU, IDAMBIENTENFE, IDATIVO, IDCONSULTADO, IDSTATUSNFE, NRACESSONFE, NRINSJURIEST, NRNSU, NRORG, NRORGINCLUSAO, NRORGULTATU, NRPROTOCOLO, NRSEQSERVICO
                   FROM NSUNFE
                  WHERE NRACESSONFE IS NOT NULL
                    AND NRACESSONFE = :NRACESSONFE ORDER BY NRNSU ";

                     
        $params = array( 
            "NRACESSONFE"  => $NRACESSONFE
        );

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $dataSet = $std->fetchAll();
    }
    
    public function getNsuXML($NRACESSONFE,$RNSU) {
        
        $sql = " SELECT DSARQXMLNSUNFE
                   FROM ARQXMLNSUNFE A
                  WHERE A.NRNSU = :NRNSU
                    AND EXISTS (SELECT NRACESSONFE
                   FROM NSUNFE N
                  WHERE NRACESSONFE = :NRACESSONFE
                    AND A.NRINSJURIEST = N.NRINSJURIEST
                    AND A.NRNSU = N.NRNSU) ";

                     
        $params = array( 
            "NRACESSONFE"  => $NRACESSONFE,
            "NRNSU"  => $RNSU
        );

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $dataSet = $std->fetchAll();
    }
}